%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global gem_name staypuft

%define _version 0.4.15
%define _summary OpenStack Foreman Installer
%define _url https://github.com/theforeman/staypuft
%define _license GPLv3

%define desc OpenStack Foreman Installer

%if "%{?scl}" == "ruby193"
    %global scl_prefix %{scl}-
    %global scl_ruby /usr/bin/ruby193-ruby
    %global scl_rake /usr/bin/ruby193-rake
%else
    %global scl_ruby /usr/bin/ruby
    %global scl_rake /usr/bin/rake
%endif

Requires: %{?scl_prefix}rubygem(foreman_discovery)
Requires: %{?scl_prefix}rubygem(foreman-tasks)
Requires: %{?scl_prefix}rubygem(wicked)
Requires: %{?scl_prefix}rubygem(deface)
Requires: %{?scl_prefix}rubygem(ipaddress)
Requires: %{?scl_prefix}rubygem(dynflow) >= 0.6.1
Requires: ceph-common
Requires: yum-plugin-versionlock
BuildRequires: %{?scl_prefix}rubygem(ipaddress)

%if 0%{?rhel} == 6 || 0%{?fedora} < 17
%if "%{?scl}" == "ruby193"
%define rubyabi 1.9.1
%else
%define rubyabi 1.8
%endif
%else
%define rubyabi 1.9.1
%endif

%global foreman_dir /usr/share/foreman
%global foreman_bundlerd_dir %{foreman_dir}/bundler.d


%if 0%{?rhel} == 6 &&  "%{?scl}" != "ruby193"
%global gem_dir %(ruby -rubygems -e 'puts Gem.dir' 2>/dev/null)
%global gem_docdir %{gem_dir}/doc/%{gem_name}-%{version}
%global gem_cache %{gem_dir}/cache/%{gem_name}-%{version}.gem
%global gem_spec %{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%global gem_instdir %{gem_dir}/gems/%{gem_name}-%{version}
%global gem_libdir %{gem_dir}/gems/%{gem_name}-%{version}/lib
%endif

Name:      %{?scl_prefix}rubygem-%{gem_name}
Version:   %{_version}
Release:   1%{?dist}
Summary:   %{_summary}
Group:     Development/Languages
License:   %{_license}
Epoch:     0
URL:       %{_url}
Source0:   http://rubygems.org/downloads/%{gem_name}-%{version}.gem

BuildArch: noarch
Provides:  %{?scl_prefix}rubygem(%{gem_name}) = %{version}
Provides:  foreman-plugin-staypuft

%if 0%{?fedora} > 18
Requires:  %{?scl_prefix}ruby(release)
%else 
Requires:  %{?scl_prefix}ruby(abi) = %{rubyabi}
%endif
Requires:  %{?scl_prefix}rubygems

%if 0%{?fedora} || "%{?scl}" == "ruby193"
BuildRequires: %{?scl_prefix}rubygems-devel
%endif
%if 0%{?fedora} > 18
BuildRequires: %{?scl_prefix}ruby(release)
%else
BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
%endif
BuildRequires: %{?scl_prefix}rubygems
BuildRequires: foreman
BuildRequires: %{?scl_prefix}rubygem(deface)
BuildRequires: %{?scl_prefix}rubygem(sass-rails)
BuildRequires: %{?scl_prefix}rubygem(uglifier)
BuildRequires: %{?scl_prefix}rubygem(foreman-tasks)
BuildRequires: %{?scl_prefix}rubygem(foreman_discovery)
BuildRequires: %{?scl_prefix}rubygem(wicked)

%description
%{desc}

%package   doc
BuildArch: noarch
Requires:  %{?scl_prefix}%{pkg_name} = %{version}-%{release}
Summary:   Documentation for %{pkg_name}

%description doc
This package contains documentation for %{pkg_name}

%prep
%{?scl:scl enable %{scl} "}
gem unpack %{SOURCE0}
%{?scl:"}
%setup -q -D -T -n %{gem_name}-%{version}

%{?scl:scl enable %{scl} "}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:"}
sed -i -e '/foreman_discovery/ s/1.4.0.rc1/1.3.0.rc2/' %{gem_name}.gemspec

%build
%{?scl:scl enable %{scl} "}
gem build %{gem_name}.gemspec
%{?scl:"}

%if 0%{?fedora} > 18
%gem_install
%else
mkdir -p .%{gem_dir}
%{?scl:scl enable %{scl} "}
gem install -V --local --install-dir .%{gem_dir} --force --rdoc \
    %{gem_name}-%{version}.gem
%{?scl:"}
%endif

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}


# compile <assets>
mkdir -p ./usr/share
cp -r %{foreman_dir} ./usr/share || echo 0

pushd ./usr/share/foreman
export GEM_PATH=%{gem_dir}:%{buildroot}%{gem_dir}
cat <<GEMFILE > ./bundler.d/%{gem_name}.rb
group :%{gem_name} do
  gem '%{gem_name}'
  gem 'sass-rails'
  gem 'bootstrap-sass'
  gem 'jquery-ui-rails'
end
GEMFILE
cat ./bundler.d/%{gem_name}.rb

unlink tmp

export BUNDLER_EXT_NOSTRICT=1
export BUNDLER_EXT_GROUPS="default assets %{gem_name}"
%{scl_rake} plugin:assets:precompile[%{gem_name}] RAILS_ENV=production --trace

popd
rm -rf ./usr
# </assets>

mkdir -p %{buildroot}%{foreman_bundlerd_dir}
cat <<GEMFILE > %{buildroot}%{foreman_bundlerd_dir}/%{gem_name}.rb
group :%{gem_name} do
  gem '%{gem_name}'
end
GEMFILE

%post
cat >> /etc/yum/pluginconf.d/versionlock.list <<EOF
%{epoch}:%{name}-%{version}-%{release}
EOF

%postun
sed -i '/%{epoch}:%{name}-%{version}-%{release}/d' /etc/yum/pluginconf.d/versionlock.list


%files
%dir %{gem_instdir}
%exclude %{gem_cache}
%{gem_spec}
%{gem_libdir}
%{gem_instdir}/app
%{gem_instdir}/db
%{gem_instdir}/config
%{gem_instdir}/public
%{gem_instdir}/Rakefile
%{foreman_bundlerd_dir}/staypuft.rb
%doc %{gem_instdir}/LICENSE

%files doc
%doc %{gem_instdir}/test
%doc %{gem_instdir}/README.md
%doc %{gem_docdir}/rdoc
%doc %{gem_docdir}/ri

%changelog
* Tue Apr 07 2015 Mike Burns <mburns@redhat.com> - 0.4.15-1
- Updates for RHEL 7.1 support

* Sat Nov 01 2014 Mike Burns <mburns@redhat.com> - 0.4.14-1
- Rebase to 0.4.14
- rhbz#1155997 - fix reboots with fencing enabled (sseago@redhat.com)

* Thu Oct 30 2014 Mike Burns <mburns@redhat.com> - 0.4.13-1
- Rebase to 0.4.13

* Thu Oct 30 2014 Mike Burns <mburns@redhat.com> - 0.4.12-1
- Rebase to 0.4.12

* Wed Oct 29 2014 Mike Burns <mburns@redhat.com> - 0.4.11-1
- Rebase to 0.4.11

* Thu Oct 23 2014 Mike Burns <mburns@redhat.com> - 0.4.10-1
- Rebase to 0.4.10

* Tue Oct 21 2014 Mike Burns <mburns@redhat.com> - 0.4.8-1
- Rebase to 0.4.8

* Mon Oct 20 2014 Mike Burns <mburns@redhat.com> - 0.4.7-1
- Rebase to 0.4.7

* Fri Oct 17 2014 Mike Burns <mburns@redhat.com> - 0.4.6-1
- Rebase to 0.4.6

* Mon Oct 13 2014 Mike Burns <mburns@redhat.com> - 0.4.5-1
- Rebase to 0.4.5

* Fri Oct 10 2014 Mike Burns <mburns@redhat.com> - 0.4.4-1
- Rebase to 0.4.4

* Fri Oct 10 2014 Lon Hohberger <lhh@redhat.com> - 0.4.3-1
- Rebase to 0.4.3

* Thu Oct 09 2014 Mike Burns <mburns@redhat.com> - 0.4.2-1
- Update to 0.4.2

* Wed Oct 08 2014 Mike Burns <mburns@redhat.com> - 0.4.1-1
- Update to 0.4.1

* Fri Oct 03 2014 Mike Burns <mburns@redhat.com> - 0.4.0-2
- Update to 0.4.0

* Fri Oct 03 2014 Mike Burns <mburns@redhat.com> - 0.3.9-2
- add versionlock for the staypuft gem rhbz#1149170

* Tue Sep 23 2014 Mike Burns <mburns@redhat.com> - 0.3.9-1
- update to 0.3.9

* Tue Sep 23 2014 Mike Burns <mburns@redhat.com> - 0.3.8-1
- Update to 0.3.8
- fix default gateway
- fix fencing ui

* Fri Sep 19 2014 Mike Burns <mburns@redhat.com> - 0.3.7-1
- Update to 0.3.7

* Tue Sep 16 2014 Mike Burns <mburns@redhat.com> - 0.3.6-1
- Update to 0.3.6

* Tue Sep 16 2014 Mike Burns <mburns@redhat.com> - 0.3.5-1
- Update to 0.3.5

* Wed Sep 10 2014 Mike Burns <mburns@redhat.com> - 0.3.4-2
- Add dependency on ceph-common

* Wed Sep 10 2014 Mike Burns <mburns@redhat.com> - 0.3.4-1
- Update to 0.3.4

* Tue Sep 09 2014 Mike Burns <mburns@redhat.com> - 0.3.3-1
- Update to 0.3.3

* Mon Sep 08 2014 Mike Burns <mburns@redhat.com> - 0.3.2-1
- Update to 0.3.2

* Thu Sep 04 2014 Mike Burns <mburns@redhat.com> - 0.3.1-1
- Rebase to upstream 0.3.1
- Various UI enhancements
- Network support

* Mon Aug 25 2014 Mike Burns <mburns@redhat.com> - 0.3.0-1
- Rebase to upstream 0.3.0

* Tue Aug 12 2014 Mike Burns <mburns@redhat.com> - 0.2.5-1
- Rebase to upstream 0.2.5

* Mon Aug 11 2014 Mike Burns <mburns@redhat.com> - 0.2.4-1
- Rebase to upstream 0.2.4

* Mon Aug 11 2014 Mike Burns <mburns@redhat.com> - 0.2.3-1
- Rebase to upstream 0.2.3

* Fri Aug 08 2014 Mike Burns <mburns@redhat.com> - 0.2.2-1
- Rebase to upstream 0.2.2

* Thu Aug 07 2014 Mike Burns <mburns@redhat.com> - 0.2.1-1
- Rebase to upstream 0.2.1

* Tue Aug 05 2014 Mike Burns <mburns@redhat.com> - 0.2.0-1
- Rebase to upstream 0.2.0

* Tue Jul 29 2014 Mike Burns <mburns@redhat.com> - 0.1.22-1
- Rebase to 0.1.22
- Fix to ignore catalog errors during pxeboot rhbz#1123463

* Fri Jul 25 2014 Mike Burns <mburns@redhat.com> - 0.1.21-1
- Rebase to 0.1.21

* Wed Jul 23 2014 Mike Burns <mburns@redhat.com> - 0.1.20-1
- Rebase to 0.1.20

* Tue Jul 22 2014 Mike Burns <mburns@redhat.com> - 0.1.19-1
- Rebase to 0.1.19

* Wed Jul 16 2014 Lon Hohberger <lhh@redhat.com> - 0.1.18-1
- Rebase to 0.1.18

* Tue Jul 15 2014 Scott Seago <sseago@redhat.com> - 0.1.17-1
- Rebase to 0.1.17

* Tue Jul 15 2014 Scott Seago <sseago@redhat.com> - 0.1.16-1
- Rebase to 0.1.16

* Mon Jul 14 2014 Scott Seago <sseago@redhat.com> - 0.1.15-1
- Rebase to 0.1.15

* Fri Jul 11 2014 Lon Hohberger <lhh@redhat.com> - 0.1.14-1
- Rebase to 0.1.14

* Fri Jul 11 2014 Lon Hohberger <lhh@redhat.com> - 0.1.13-1
- Rebase to 0.1.13

* Thu Jul 10 2014 Lon Hohberger <lhh@redhat.com> 0.1.12-1
- Update to upstream 0.1.12

* Thu Jul 10 2014 Lon Hohberger <lhh@redhat.com> 0.1.11-1
- Update to upstream 0.1.11

* Thu Jul 10 2014 Lon Hohberger <lhh@redhat.com> 0.1.10-1
- Update to upstream 0.1.10

* Thu Jul 10 2014 Lon Hohberger <lhh@redhat.com> 0.1.8.3-1
- Update to upstream 0.1.8.3

* Wed Jul 09 2014 Lon Hohberger <lhh@redhat.com> 0.1.8.2-1
- Update to upstream 0.1.8.2

* Wed Jul 09 2014 Lon Hohberger <lhh@redhat.com> 0.1.8.1-1
- Update to upstream 0.1.8.1

* Tue Jul 08 2014 Lon Hohberger <lhh@redhat.com> 0.1.8-1
- Update to upstream 0.1.8

* Thu Jul 03 2014 Mike Burns <mburns@redhat.com> 0.1.7-1
- Update to upstream 0.1.7

* Thu Jul 03 2014 Mike Burns <mburns@redhat.com> 0.1.5.2-1
- Various UI fixes rhbz#1102394

* Wed Jul 02 2014 Mike Burns <mburns@redhat.com> 0.1.5.1-1
- UI Refactor

* Thu Jun 26 2014 Mike Burns <mburns@redhat.com> 0.1.5-1
- update dependencies rhbz#1113631

* Wed Jun 18 2014 Mike Burns <mburns@redhat.com> 0.1.4-1
- Remove nexus configurations rhbz#1108561
- fix various UI issues

* Mon Jun 16 2014 Mike Burns <mburns@redhat.com> 0.1.3-1
- fix capitalization in mac address check (lars@redhat.com) rhbz#1109345

* Fri Jun 13 2014 Mike Burns <mburns@redhat.com> 0.1.2-1
- fix cinder host puppetclass (sseago@redhat.com) rhbz#1107794
- detect correct ip address (git@pitr.ch) rhbz#1106605
- add missing ml2_firewall_driver param (sseago@redhat.com)
- update to cinder based on astapor updates (sseago@redhat.com)
- set ML2 as default (sseago@redhat.com)

* Fri Jun 06 2014 Marek Hulan <mhulan@redhat.com> 0.1.1-1
- Update staypuft to 0.1.1 (mhulan@redhat.com)

* Wed Jun 04 2014 Mike Burns <mburns@redhat.com> 0.1.0-1
- Add rabbit/qpid switch (sseago@redhat.com)
- import/export config (sseago@redhat.com)
- rename lvm block to cinder block (sseago@redhat.com) rhbz#1100459
- allow deployed hosts to be unassigned (git@pitr.ch)
- consolidate neutron network services (sseago@redhat.com) rhbz#1093414
- resolve changes in new astapor modules (sseago@redhat.com)
- remove redundant configs (jrist@redhat.com)

* Thu May 22 2014 Mike Burns <mburns@redhat.com> 0.0.16-1
- fix masking of sub-man passwords (mhulan@redhat.com) rhbz#1098776
- fix hash and array values in UI (pchalupa@redhat.com) rhbz#1100294

* Thu May 22 2014 Mike Burns <mburns@redhat.com> 0.0.15-1
- parameter cleanup (sseago@redhat.com)

* Tue May 20 2014 Mike Burns <mburns@redhat.com> 0.0.14-1
- rhbz#1098776 hide subscription manager password in UI (mhulan@redhat.com)
- rhbz#1093055 support multiple deployments (pchalupa@redhat.com)

* Thu May 15 2014 Marek Hulan <mhulan@redhat.com> 0.0.13-1
- Update staypuft to 0.0.13 (mhulan@redhat.com)

* Fri May 02 2014 Mike Burns <mburns@redhat.com> 0.0.12-1
- Update to upstream 0.0.12 (mhulan@redhat.com)

* Wed Apr 23 2014 Mike Burns <mburns@redhat.com> 0.0.11-5
- Staypuft update to 0.0.11 (mhulan@redhat.com)

* Tue Apr 22 2014 Mike Burns <mburns@redhat.com> 0.0.10-1
- Staypuft update to 0.0.10 (mhulan@redhat.com)

* Tue Apr 15 2014 Marek Hulan <mhulan@redhat.com> 0.0.9-1
- Staypuft update to 0.0.9 (mhulan@redhat.com)

* Mon Apr 14 2014 Marek Hulan <mhulan@redhat.com> 0.0.8-1
- Update staypuft to 0.0.8 (mhulan@redhat.com)

* Thu Apr 10 2014 Marek Hulan <mhulan@redhat.com> 0.0.7-1
- Update staypuft (mhulan@redhat.com)

* Thu Apr 10 2014 Marek Hulan <mhulan@redhat.com> 0.0.6-1
- Update staypuft (mhulan@redhat.com)

* Tue Apr 08 2014 Marek Hulan <mhulan@redhat.com> 0.0.4-3
- Fix requirement for packaged staypuft gemfile (mhulan@redhat.com)

* Tue Apr 08 2014 Marek Hulan <mhulan@redhat.com> 0.0.4-2
- Fix staypuft doc dependency (mhulan@redhat.com)
- Add foreman-plugin-staypuft provides (dcleal@redhat.com)
- Remove superfluous quotes (dcleal@redhat.com)

* Tue Apr 08 2014 Marek Hulan <mhulan@redhat.com> 0.0.4-1
- Update staypuft to 0.0.4 (mhulan@redhat.com)
- Precompile assets of staypuft (mhulan@redhat.com)

* Mon Apr 07 2014 Marek Hulan <mhulan@redhat.com> 0.0.3-1
- Update staypuft to 0.0.3 (mhulan@redhat.com)

* Fri Apr 04 2014 Marek Hulan <mhulan@redhat.com> 0.0.2-4
- Hopefully last hack staypuft 0.0.2 version (mhulan@redhat.com)

* Fri Apr 04 2014 Marek Hulan <mhulan@redhat.com> 0.0.2-3
- Another hacked version of staypuft (mhulan@redhat.com)

* Fri Apr 04 2014 Marek Hulan <mhulan@redhat.com> 0.0.2-2
- Hacked staypuft version without oj dependency (mhulan@redhat.com)

* Fri Apr 04 2014 Marek Hulan <mhulan@redhat.com> 0.0.2-1
- Update staypuft to 0.0.2 (mhulan@redhat.com)

* Wed Apr 02 2014 Marek Hulan <mhulan@redhat.com> 0.0.1-2
- Integrate staypuft into foreman (mhulan@redhat.com)

* Wed Apr 02 2014 Marek Hulan <mhulan@redhat.com> 0.0.1-1
- new package built with tito


